Index: uspace/lib/c/generic/adt/measured_strings.c
===================================================================
--- uspace/lib/c/generic/adt/measured_strings.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/adt/measured_strings.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -55,11 +55,11 @@
  *			appended with the terminating zero ('\0') character
  *			otherwise.
- * @return		The new bundled character string with measured length.
- * @return		NULL if there is not enough memory left.
- */
-measured_string_t *
+ * @returns		The new bundled character string with measured length.
+ * @returns		NULL if there is not enough memory left.
+ */
+measured_string_ref
 measured_string_create_bulk(const char *string, size_t length)
 {
-	measured_string_t *new;
+	measured_string_ref new;
 
 	if (length == 0) {
@@ -67,5 +67,5 @@
 			length++;
 	}
-	new = (measured_string_t *) malloc(sizeof(measured_string_t) +
+	new = (measured_string_ref) malloc(sizeof(measured_string_t) +
 	    (sizeof(char) * (length + 1)));
 	if (!new)
@@ -84,16 +84,16 @@
  *
  * @param[in] source	The source measured string to be copied.
- * @return		The copy of the given measured string.
- * @return		NULL if the source parameter is NULL.
- * @return		NULL if there is not enough memory left.
- */
-measured_string_t *measured_string_copy(measured_string_t *source)
-{
-	measured_string_t *new;
+ * @returns		The copy of the given measured string.
+ * @returns		NULL if the source parameter is NULL.
+ * @returns		NULL if there is not enough memory left.
+ */
+measured_string_ref measured_string_copy(measured_string_ref source)
+{
+	measured_string_ref new;
 
 	if (!source)
 		return NULL;
 
-	new = (measured_string_t *) malloc(sizeof(measured_string_t));
+	new = (measured_string_ref) malloc(sizeof(measured_string_t));
 	if (new) {
 		new->value = (char *) malloc(source->length + 1);
@@ -120,16 +120,16 @@
  *			actual character strings.
  *  @param[in] count	The size of the measured strings array.
- *  @return		EOK on success.
- *  @return		EINVAL if the strings or data parameter is NULL.
- *  @return		EINVAL if the count parameter is zero (0).
- *  @return		EINVAL if the sent array differs in size.
- *  @return		EINVAL if there is inconsistency in sent measured
+ *  @returns		EOK on success.
+ *  @returns		EINVAL if the strings or data parameter is NULL.
+ *  @returns		EINVAL if the count parameter is zero (0).
+ *  @returns		EINVAL if the sent array differs in size.
+ *  @returns		EINVAL if there is inconsistency in sent measured
  *			strings' lengths (should not occur).
- *  @return		ENOMEM if there is not enough memory left.
- *  @return		Other error codes as defined for the
+ *  @returns		ENOMEM if there is not enough memory left.
+ *  @returns		Other error codes as defined for the
  *			async_data_write_finalize() function.
  */
 int
-measured_strings_receive(measured_string_t **strings, char **data,
+measured_strings_receive(measured_string_ref *strings, char **data,
     size_t count)
 {
@@ -166,5 +166,5 @@
 	(*data)[lengths[count] - 1] = '\0';
 
-	*strings = (measured_string_t *) malloc(sizeof(measured_string_t) *
+	*strings = (measured_string_ref) malloc(sizeof(measured_string_t) *
 	    count);
 	if (!*strings) {
@@ -209,8 +209,8 @@
  * @param[in] strings	The measured strings array to be processed.
  * @param[in] count	The measured strings array size.
- * @return		The computed sizes array.
- * @return		NULL if there is not enough memory left.
- */
-static size_t *prepare_lengths(const measured_string_t *strings, size_t count)
+ * @returns		The computed sizes array.
+ * @returns		NULL if there is not enough memory left.
+ */
+static size_t *prepare_lengths(const measured_string_ref strings, size_t count)
 {
 	size_t *lengths;
@@ -238,15 +238,15 @@
  * @param[in] strings	The measured strings array to be transferred.
  * @param[in] count	The measured strings array size.
- * @return		EOK on success.
- * @return		EINVAL if the strings parameter is NULL.
- * @return		EINVAL if the count parameter is zero (0).
- * @return		EINVAL if the calling module does not accept the given
+ * @returns		EOK on success.
+ * @returns		EINVAL if the strings parameter is NULL.
+ * @returns		EINVAL if the count parameter is zero (0).
+ * @returns		EINVAL if the calling module does not accept the given
  *			array size.
- * @return		EINVAL if there is inconsistency in sent measured
+ * @returns		EINVAL if there is inconsistency in sent measured
  *			strings' lengths (should not occur).
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			async_data_read_finalize() function.
  */
-int measured_strings_reply(const measured_string_t *strings, size_t count)
+int measured_strings_reply(const measured_string_ref strings, size_t count)
 {
 	size_t *lengths;
@@ -302,14 +302,14 @@
  *			actual character strings.
  * @param[in] count	The size of the measured strings array.
- * @return		EOK on success.
- * @return		EINVAL if the strings or data parameter is NULL.
- * @return		EINVAL if the phone or count parameter is not positive.
- * @return		EINVAL if the sent array differs in size.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the strings or data parameter is NULL.
+ * @returns		EINVAL if the phone or count parameter is not positive.
+ * @returns		EINVAL if the sent array differs in size.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			async_data_read_start() function.
  */
 int
-measured_strings_return(int phone, measured_string_t **strings, char **data,
+measured_strings_return(int phone, measured_string_ref *strings, char **data,
     size_t count)
 {
@@ -339,5 +339,5 @@
 	}
 
-	*strings = (measured_string_t *) malloc(sizeof(measured_string_t) *
+	*strings = (measured_string_ref) malloc(sizeof(measured_string_t) *
 	    count);
 	if (!*strings) {
@@ -378,12 +378,12 @@
  * @param[in] strings	The measured strings array to be transferred.
  * @param[in] count	The measured strings array size.
- * @return		EOK on success.
- * @return		EINVAL if the strings parameter is NULL.
- * @return		EINVAL if the phone or count parameter is not positive.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the strings parameter is NULL.
+ * @returns		EINVAL if the phone or count parameter is not positive.
+ * @returns		Other error codes as defined for the
  *			async_data_write_start() function.
  */
 int
-measured_strings_send(int phone, const measured_string_t *strings,
+measured_strings_send(int phone, const measured_string_ref strings,
     size_t count)
 {
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/async.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -536,5 +536,5 @@
 		if (callid)
 			ipc_answer_0(callid, ENOMEM);
-		return (uintptr_t) NULL;
+		return NULL;
 	}
 	
@@ -556,5 +556,5 @@
 		if (callid)
 			ipc_answer_0(callid, ENOMEM);
-		return (uintptr_t) NULL;
+		return NULL;
 	}
 	
Index: uspace/lib/c/generic/io/klog.c
===================================================================
--- uspace/lib/c/generic/io/klog.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/io/klog.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -52,5 +52,5 @@
 void klog_update(void)
 {
-	(void) __SYSCALL3(SYS_KLOG, 1, (uintptr_t) NULL, 0);
+	(void) __SYSCALL3(SYS_KLOG, 1, NULL, 0);
 }
 
Index: uspace/lib/c/generic/net/icmp_api.c
===================================================================
--- uspace/lib/c/generic/net/icmp_api.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/icmp_api.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -66,12 +66,12 @@
  * @param[in] addr	The target host address.
  * @param[in] addrlen	The torget host address length.
- * @return		ICMP_ECHO on success.
- * @return		ETIMEOUT if the reply has not arrived before the
+ * @returns		ICMP_ECHO on success.
+ * @returns		ETIMEOUT if the reply has not arrived before the
  *			timeout.
- * @return		ICMP type of the received error notification.
- * @return		EINVAL if the addrlen parameter is less or equal to
+ * @returns		ICMP type of the received error notification.
+ * @returns		EINVAL if the addrlen parameter is less or equal to
  *			zero.
- * @return		ENOMEM if there is not enough memory left.
- * @return		EPARTY if there was an internal error.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		EPARTY if there was an internal error.
  */
 int
Index: uspace/lib/c/generic/net/icmp_common.c
===================================================================
--- uspace/lib/c/generic/net/icmp_common.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/icmp_common.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -50,6 +50,6 @@
  * @param[in] timeout	The connection timeout in microseconds. No timeout if
  *			set to zero.
- * @return		The ICMP module phone on success.
- * @return		ETIMEOUT if the connection timeouted.
+ * @returns		The ICMP module phone on success.
+ * @returns		ETIMEOUT if the connection timeouted.
  */
 int icmp_connect_module(services_t service, suseconds_t timeout)
Index: uspace/lib/c/generic/net/inet.c
===================================================================
--- uspace/lib/c/generic/net/inet.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/inet.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -51,8 +51,8 @@
  *  @param[out] address	The character buffer to be filled.
  *  @param[in] length	The buffer length.
- *  @return		EOK on success.
- *  @return		EINVAL if the data or address parameter is NULL.
- *  @return		ENOMEM if the character buffer is not long enough.
- *  @return		ENOTSUP if the address family is not supported.
+ *  @returns		EOK on success.
+ *  @returns		EINVAL if the data or address parameter is NULL.
+ *  @returns		ENOMEM if the character buffer is not long enough.
+ *  @returns		ENOTSUP if the address family is not supported.
  */
 int
@@ -101,8 +101,8 @@
  *  @param[in] address	The character buffer to be parsed.
  *  @param[out] data	The address data to be filled.
- *  @return		EOK on success.
- *  @return		EINVAL if the data parameter is NULL.
- *  @return		ENOENT if the address parameter is NULL.
- *  @return		ENOTSUP if the address family is not supported.
+ *  @returns		EOK on success.
+ *  @returns		EINVAL if the data parameter is NULL.
+ *  @returns		ENOENT if the address parameter is NULL.
+ *  @returns		ENOTSUP if the address family is not supported.
  */
 int inet_pton(uint16_t family, const char *address, uint8_t *data)
Index: uspace/lib/c/generic/net/modules.c
===================================================================
--- uspace/lib/c/generic/net/modules.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/modules.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -159,5 +159,5 @@
  *
  * @param[in] need	The needed module service.
- * @return		The phone of the needed service.
+ * @returns		The phone of the needed service.
  */
 int connect_to_service(services_t need)
@@ -171,6 +171,6 @@
  *  @param[in] timeout	The connection timeout in microseconds. No timeout if
  *			set to zero (0).
- *  @return		The phone of the needed service.
- *  @return		ETIMEOUT if the connection timeouted.
+ *  @returns		The phone of the needed service.
+ *  @returns		ETIMEOUT if the connection timeouted.
  */
 int connect_to_service_timeout(services_t need, suseconds_t timeout)
@@ -204,9 +204,9 @@
  * @param[out] data	The data buffer to be filled.
  * @param[out] length	The buffer length.
- * @return		EOK on success.
- * @return		EBADMEM if the data or the length parameter is NULL.
- * @return		EINVAL if the client does not send data.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the data or the length parameter is NULL.
+ * @returns		EINVAL if the client does not send data.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			async_data_write_finalize() function.
  */
@@ -242,9 +242,9 @@
  * @param[in] data	The data buffer to be sent.
  * @param[in] data_length The buffer length.
- * @return		EOK on success.
- * @return		EINVAL if the client does not expect the data.
- * @return		EOVERFLOW if the client does not expect all the data.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the client does not expect the data.
+ * @returns		EOVERFLOW if the client does not expect all the data.
  *			Only partial data are transfered.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			async_data_read_finalize() function.
  */
Index: uspace/lib/c/generic/net/packet.c
===================================================================
--- uspace/lib/c/generic/net/packet.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/packet.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -62,5 +62,8 @@
 
 /** Type definition of the packet map page. */
-typedef packet_t *packet_map_t[PACKET_MAP_SIZE];
+typedef packet_t packet_map_t[PACKET_MAP_SIZE];
+
+/** Type definition of the packet map page pointer. */
+typedef packet_map_t * packet_map_ref;
 
 /** Packet map.
@@ -82,6 +85,6 @@
 /** Initializes the packet map.
  *
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int pm_init(void)
@@ -101,11 +104,11 @@
  *
  * @param[in] packet_id	The packet identifier to be found.
- * @return		The found packet reference.
- * @return		NULL if the mapping does not exist.
- */
-packet_t *pm_find(packet_id_t packet_id)
-{
-	packet_map_t *map;
-	packet_t *packet;
+ * @returns		The found packet reference.
+ * @returns		NULL if the mapping does not exist.
+ */
+packet_t pm_find(packet_id_t packet_id)
+{
+	packet_map_ref map;
+	packet_t packet;
 
 	if (!packet_id)
@@ -130,12 +133,12 @@
  *
  * @param[in] packet	The packet to be remembered.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		EINVAL if the packet map is not initialized.
- * @return		ENOMEM if there is not enough memory left.
- */
-int pm_add(packet_t *packet)
-{
-	packet_map_t *map;
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		EINVAL if the packet map is not initialized.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int pm_add(packet_t packet)
+{
+	packet_map_ref map;
 	int rc;
 
@@ -151,5 +154,5 @@
 	} else {
 		do {
-			map = (packet_map_t *) malloc(sizeof(packet_map_t));
+			map = (packet_map_ref) malloc(sizeof(packet_map_t));
 			if (!map) {
 				fibril_rwlock_write_unlock(&pm_globals.lock);
@@ -177,6 +180,6 @@
 	int count;
 	int index;
-	packet_map_t *map;
-	packet_t *packet;
+	packet_map_ref map;
+	packet_t packet;
 
 	fibril_rwlock_write_lock(&pm_globals.lock);
@@ -205,11 +208,11 @@
  * @param[in] order	The packet order value.
  * @param[in] metric	The metric value of the packet.
- * @return		EOK on success.
- * @return		EINVAL if the first parameter is NULL.
- * @return		EINVAL if the packet is not valid.
- */
-int pq_add(packet_t **first, packet_t *packet, size_t order, size_t metric)
-{
-	packet_t *item;
+ * @returns		EOK on success.
+ * @returns		EINVAL if the first parameter is NULL.
+ * @returns		EINVAL if the packet is not valid.
+ */
+int pq_add(packet_t * first, packet_t packet, size_t order, size_t metric)
+{
+	packet_t item;
 
 	if (!first || !packet_is_valid(packet))
@@ -249,11 +252,11 @@
  * @param[in] first	The first packet of the queue.
  * @param[in] order	The packet order value.
- * @return		The packet with the given order.
- * @return		NULL if the first packet is not valid.
- * @return		NULL if the packet is not found.
- */
-packet_t *pq_find(packet_t *packet, size_t order)
-{
-	packet_t *item;
+ * @returns		The packet with the given order.
+ * @returns		NULL if the first packet is not valid.
+ * @returns		NULL if the packet is not found.
+ */
+packet_t pq_find(packet_t packet, size_t order)
+{
+	packet_t item;
 
 	if (!packet_is_valid(packet))
@@ -275,10 +278,10 @@
  * @param[in] packet	The packet in the queue.
  * @param[in] new_packet The new packet to be inserted.
- * @return		EOK on success.
- * @return		EINVAL if etiher of the packets is invalid.
- */
-int pq_insert_after(packet_t *packet, packet_t *new_packet)
-{
-	packet_t *item;
+ * @returns		EOK on success.
+ * @returns		EINVAL if etiher of the packets is invalid.
+ */
+int pq_insert_after(packet_t packet, packet_t new_packet)
+{
+	packet_t item;
 
 	if (!packet_is_valid(packet) || !packet_is_valid(new_packet))
@@ -298,13 +301,13 @@
  *
  * @param[in] packet	The packet to be detached.
- * @return		The next packet in the queue. If the packet is the first
+ * @returns		The next packet in the queue. If the packet is the first
  *			one of the queue, this becomes the new first one.
- * @return		NULL if there is no packet left.
- * @return		NULL if the packet is not valid.
- */
-packet_t *pq_detach(packet_t *packet)
-{
-	packet_t *next;
-	packet_t *previous;
+ * @returns		NULL if there is no packet left.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_detach(packet_t packet)
+{
+	packet_t next;
+	packet_t previous;
 
 	if (!packet_is_valid(packet))
@@ -328,8 +331,8 @@
  * @param[in] order	The packet order value.
  * @param[in] metric	The metric value of the packet.
- * @return		EOK on success.
- * @return		EINVAL if the packet is invalid.
- */
-int pq_set_order(packet_t *packet, size_t order, size_t metric)
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is invalid.
+ */
+int pq_set_order(packet_t packet, size_t order, size_t metric)
 {
 	if (!packet_is_valid(packet))
@@ -346,8 +349,8 @@
  * @param[out] order	The packet order value.
  * @param[out] metric	The metric value of the packet.
- * @return		EOK on success.
- * @return		EINVAL if the packet is invalid.
- */
-int pq_get_order(packet_t *packet, size_t *order, size_t *metric)
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is invalid.
+ */
+int pq_get_order(packet_t packet, size_t *order, size_t *metric)
 {
 	if (!packet_is_valid(packet))
@@ -372,8 +375,8 @@
  *			packets after its detachment.
  */
-void pq_destroy(packet_t *first, void (*packet_release)(packet_t *packet))
-{
-	packet_t *actual;
-	packet_t *next;
+void pq_destroy(packet_t first, void (*packet_release)(packet_t packet))
+{
+	packet_t actual;
+	packet_t next;
 
 	actual = first;
@@ -391,9 +394,9 @@
  *
  * @param[in] packet	The packet queue member.
- * @return		The next packet in the queue.
- * @return		NULL if there is no next packet.
- * @return		NULL if the packet is not valid.
- */
-packet_t *pq_next(packet_t *packet)
+ * @returns		The next packet in the queue.
+ * @returns		NULL if there is no next packet.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_next(packet_t packet)
 {
 	if (!packet_is_valid(packet))
@@ -406,9 +409,9 @@
  *
  * @param[in] packet	The packet queue member.
- * @return		The previous packet in the queue.
- * @return		NULL if there is no previous packet.
- * @return		NULL if the packet is not valid.
- */
-packet_t *pq_previous(packet_t *packet)
+ * @returns		The previous packet in the queue.
+ * @returns		NULL if there is no previous packet.
+ * @returns		NULL if the packet is not valid.
+ */
+packet_t pq_previous(packet_t packet)
 {
 	if (!packet_is_valid(packet))
